function [ val ] = fct_gp_hat_1d( p, k )
%FCT_GP Summary of this function goes here
%   Detailed explanation goes here

val = zeros(size(k));
i_even = find(mod(k, 2)==0);
k_even = k(i_even);
i_odd = find(mod(k, 2)==1);
k_odd = k(i_odd);
i_zero = find(k==0);

if p == 1
  Np = sqrt(0.2e1) * sqrt(0.1e1 / (-0.16e2 + 0.9e1 * pi) * pi);
  val(i_even) = 2 / pi ./ (k_even .^ 2 - 1);
  val(i_zero) = 0.2e1 * (-0.1e1 + pi) / pi;
elseif p == 2
  Np = 0.2e1 / 0.35e2 * sqrt(0.70e2);
  val(i_odd) = (2i) * (-2) / pi ./ (k_odd .^ 2 - 4) ./ k_odd;
  val(i_zero) = 2;
elseif p == 3
  Np = 0.4e1 * sqrt(0.3e1) * sqrt(pi / (0.207e3 * pi - 0.256e3));
  val(i_even) = 0.6e1 * (-2) / pi ./ (k_even .^ 4 - 10 * k_even .^ 2 + 9);
  val(i_zero) = 0.2e1 / 0.3e1 * (-0.2e1 + 0.3e1 * pi) / pi;
elseif p == 4
  Np = 0.8e1 / 0.547e3 * sqrt(0.1094e4);
  val(i_odd) = (-24i) * (-2) / pi ./ k_odd ./ (k_odd .^ 4 - 20 * k_odd .^ 2 + 64);
  val(i_zero) = 2;
elseif p == 23
  Np = 0.27428474595189747620;
  val(i_even) = 0.6e1 * (-2) / pi ./ (k_even .^ 4 - 10 * k_even .^ 2 + 9);
  val(i_odd) = (2i) * (-2) / pi ./ (k_odd .^ 2 - 4) ./ k_odd;
  val(i_zero) = 0.2e1 / 0.3e1 * (-0.2e1 + 0.3e1 * pi) / pi + 2;
elseif p == 34
  Np = 0.27533866163536556;
  val(i_even) = 0.6e1 * (-2) / pi ./ (k_even .^ 4 - 10 * k_even .^ 2 + 9);
  val(i_odd) = (-24i) * (-2) / pi ./ k_odd ./ (k_odd .^ 4 - 20 * k_odd .^ 2 + 64);
  val(i_zero) = 0.2e1 / 0.3e1 * (-0.2e1 + 0.3e1 * pi) / pi + 2;
else
  error('invalid p');
end

val = Np * val;

end

