function [ val ] = fct_gp_1d( p, x )
%FCT_GP_1D Computes value of factors of G_p^d.

if p == 1
  Np = sqrt(0.2e1) * sqrt(0.1e1 / (-0.16e2 + 0.9e1 * pi) * pi);
elseif p == 2
  Np = 0.2e1 / 0.35e2 * sqrt(0.70e2);
elseif p == 3
  Np = 0.4e1 * sqrt(0.3e1) * sqrt(pi / (0.207e3 * pi - 0.256e3));
elseif p == 4
  Np = 0.8e1 / 0.547e3 * sqrt(0.1094e4);
elseif p==23
elseif p==34
else
  error('invalid p');
end

if p==23
  val = (2+sign(x-1/2).*sin(2*pi*x).^2 + 2+sign(x-1/2).*sin(2*pi*x).^3) * 0.27428474595189747620;
elseif p==34
  val = (2+sign(x-1/2).*sin(2*pi*x).^3 + 2+sign(x-1/2).*sin(2*pi*x).^4) * 0.27533866163536556;
else
  val = Np * (2 + sign(x - 1/2) .* sin(2 * pi * x).^p);


end

